unit UfrmMLeader;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ComObj, ActiveX, AutoCAD_TLB, Grids, ComCtrls,
  ExtCtrls;

type
  TfrmMLeader = class(TForm)
    PageControl1: TPageControl;
    tshStyles: TTabSheet;
    tshMLeaders: TTabSheet;
    lblLeaderType: TLabel;
    lblArrowheadType: TLabel;
    lblArrowheadSize: TLabel;
    lblDoglegLength: TLabel;
    lblLandingGap: TLabel;
    lblTextRightAttachmentType: TLabel;
    lblTextLeftAttachmentType: TLabel;
    lblBlockConnectionType: TLabel;
    lblContentType: TLabel;
    lblContentBlockType: TLabel;
    lblTextString: TLabel;
    lblTextDirection: TLabel;
    lblTextHeight: TLabel;
    lblTextWidth: TLabel;
    lblTextJustify: TLabel;
    lblScaleFactor: TLabel;
    lblTextRotation: TLabel;
    lblTextLineSpacingFactor: TLabel;
    lblTextLineSpacingDistance: TLabel;
    lblTextLineSpacingStyle: TLabel;
    cbLeaderType: TComboBox;
    cbArrowheadType: TComboBox;
    edArrowheadSize: TEdit;
    chbDogLegged: TCheckBox;
    edDoglegLength: TEdit;
    edLandingGap: TEdit;
    cbTextLeftAttachmentType: TComboBox;
    cbTextRightAttachmentType: TComboBox;
    cbBlockConnectionType: TComboBox;
    cbContentType: TComboBox;
    cbContentBlockType: TComboBox;
    edTextString: TEdit;
    chbTextFrameDisplay: TCheckBox;
    chbTextBackgroundFill: TCheckBox;
    cbTextDirection: TComboBox;
    edTextHeight: TEdit;
    edTextWidth: TEdit;
    edScaleFactor: TEdit;
    cbTextJustify: TComboBox;
    edTextRotation: TEdit;
    edTextLineSpacingFactor: TEdit;
    edTextLineSpacingDistance: TEdit;
    cbTextLineSpacingStyle: TComboBox;
    lblMLeaderStyles: TLabel;
    lblStyleProps: TLabel;
    btGetMLeaderStyles: TButton;
    lbMLeaderStyles: TListBox;
    sgStyleProps: TStringGrid;
    gbAddMLeaderStyle: TGroupBox;
    lblNewStyleName: TLabel;
    btnAddMLeaderStyle: TButton;
    edNewStyleName: TEdit;
    btnAddFullMLeader: TButton;
    Bevel1: TBevel;
    btnSetCurrStyle: TButton;
    btnAddTxtMLeader: TButton;
    btnAddBlkMLeader: TButton;
    btnAdd2cMLeader: TButton;
    btnAdd3MLeader: TButton;
    btnGetMLeaderInfo: TButton;
    btnAdd2MLeader: TButton;
    btnAddSomeMLeader: TButton;
    procedure FormCreate(Sender: TObject);
    procedure btGetMLeaderStylesClick(Sender: TObject);
    procedure btnAddFullMLeaderClick(Sender: TObject);
    procedure btnAddMLeaderStyleClick(Sender: TObject);
    procedure lbMLeaderStylesClick(Sender: TObject);
    procedure lbMLeaderStylesDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure btnSetCurrStyleClick(Sender: TObject);
    procedure btnAddTxtMLeaderClick(Sender: TObject);
    procedure btnAddBlkMLeaderClick(Sender: TObject);
    procedure btnAdd2cMLeaderClick(Sender: TObject);
    procedure btnAdd3MLeaderClick(Sender: TObject);
    procedure btnGetMLeaderInfoClick(Sender: TObject);
    procedure btnAddSomeMLeaderClick(Sender: TObject);
    procedure btnAdd2MLeaderClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private

  public
    { Public declarations }
  end;

var
  frmMLeader: TfrmMLeader;
  Acad: OleVariant;

implementation

{$R *.dfm}

uses
  Utils;

procedure TfrmMLeader.FormCreate(Sender: TObject);
begin
  Acad:= GetActiveOleObject('AutoCAD.Application');
  Caption:= Application.Title;
  
  cbContentType.ItemIndex:= 2;
  cbContentBlockType.ItemIndex:= 2;
  cbBlockConnectionType.ItemIndex:= 1;
  cbLeaderType.ItemIndex:= 1;
  cbArrowheadType.ItemIndex:= 0;
  cbTextRightAttachmentType.Items.Assign(cbTextLeftAttachmentType.Items);
  cbTextLeftAttachmentType.ItemIndex:= 3;
  cbTextRightAttachmentType.ItemIndex:= 3;
  cbTextDirection.ItemIndex:= 0;
  cbTextJustify.ItemIndex:= 0;
  cbTextLineSpacingStyle.ItemIndex:= 0;
  with sgStyleProps do
  begin
    Cells[0, 0]:= '';
    Cells[1, 0]:= '';
  end;
end;

procedure TfrmMLeader.FormDestroy(Sender: TObject);
begin
  VariantClear(Acad);
end;

procedure TfrmMLeader.btGetMLeaderStylesClick(Sender: TObject);
var
  MLeaderDictionary, MLeaderStyle: OleVariant;
  i, N, C: Integer;
  CurrStyle, S: String;
begin
  //  
  try
    MLeaderDictionary:= Acad.ActiveDocument.Dictionaries.Item('ACAD_MLEADERSTYLE');
  except
    raise EOleError.Create(' MultiLeader  !');
  end;
  //  
  CurrStyle:= Acad.ActiveDocument.GetVariable('CMLEADERSTYLE');
  //      MultiLeader
  lbMLeaderStyles.Clear;
  lbMLeaderStyles.Items.BeginUpdate;
  try
    N:= MLeaderDictionary.Count; //    
    for i:= 0 to N - 1 do        //   
    begin
      //    = 'AcDbMLeaderStyle' -     MLeader
      if MLeaderDictionary.Item(i).ObjectName = 'AcDbMLeaderStyle' then
      begin
        MLeaderStyle:= MLeaderDictionary.Item(i);
        S:= MLeaderStyle.Name;
        if AnsiCompareText(S, CurrStyle) = 0 then //   ?
          C:= 1 //  -   " "
        else
          C:= 0;
        //     " "
        lbMLeaderStyles.Items.AddObject(S, TObject(C));
      end;          
    end;
  finally
    lbMLeaderStyles.Items.EndUpdate;
  end;
  lbMLeaderStyles.ItemIndex:= 0;
  lbMLeaderStylesClick(lbMLeaderStyles);
end;

procedure TfrmMLeader.lbMLeaderStylesClick(Sender: TObject);
var
  MLeaderDictionary, AStyle: OleVariant;
  i, j, N: Integer;
  AName: String;
  Founded: Boolean;
  AcCmColor: OleVariant;
begin
  if lbMLeaderStyles.ItemIndex < 0 then Exit;
  //  
  try
    MLeaderDictionary:= Acad.ActiveDocument.Dictionaries.Item('ACAD_MLEADERSTYLE');
  except
    raise EOleError.Create(' MultiLeader  !');
  end;
  //  
  AName:= lbMLeaderStyles.Items[lbMLeaderStyles.ItemIndex];
  //   AName
  N:= MLeaderDictionary.Count;
  Founded:= False;
  for i:= 0 to N - 1 do
  begin
    if MLeaderDictionary.Item(i).ObjectName = 'AcDbMLeaderStyle' then
    begin
      AStyle:= MLeaderDictionary.Item(i);
      if AnsiCompareText(AStyle.Name, AName) = 0 then
      begin
        Founded:= True;
        Break;
      end;
    end;
  end;
  //  AName   -      
  if not Founded then
  begin
    with sgStyleProps do
      for i:= 0 to ColCount - 1 do
        for j:= 1 to RowCount - 1 do
          Cells[i, j]:= '';
    raise Exception.CreateFmt(' "%s"  !', [AName]);
  end;
  //    AName
  with sgStyleProps do
  begin
    Cells[0,  1]:= 'Name';                         Cells[1,  1]:= AStyle.Name;
    Cells[0,  2]:= 'Description';                  Cells[1,  2]:= AStyle.Description;
    Cells[0,  3]:= 'BitFlags';                     Cells[1,  3]:= IntToStr(Integer(AStyle.BitFlags));
    Cells[0,  4]:= 'ContentType';                  Cells[1,  4]:= AcMLeaderContentTypeToStr(AStyle.ContentType);
    Cells[0,  5]:= 'DrawMLeaderOrderType';         Cells[1,  5]:= AcDrawMLeaderOrderTypeToStr(AStyle.DrawMLeaderOrderType);
    Cells[0,  6]:= 'DrawLeaderOrderType';          Cells[1,  6]:= AcDrawLeaderOrderTypeToStr(AStyle.DrawLeaderOrderType);
    Cells[0,  7]:= 'MaxLeaderSegmentsPoints';      Cells[1,  7]:= IntToStr(Integer(AStyle.MaxLeaderSegmentsPoints));
    Cells[0,  8]:= 'FirstSegmentAngleConstraint';  Cells[1,  8]:= AcDrawLeaderOrderTypeToStr(AStyle.FirstSegmentAngleConstraint);
    Cells[0, 09]:= 'SecondSegmentAngleConstraint'; Cells[1, 09]:= AcDrawLeaderOrderTypeToStr(AStyle.SecondSegmentAngleConstraint);
    Cells[0, 10]:= 'LeaderLineType';               Cells[1, 10]:= AcMLeaderTypeToStr(AStyle.LeaderLineType);
    Cells[0, 11]:= 'LeaderLineColor';              AcCmColor:= AStyle.LeaderLineColor; Cells[1, 11]:= Format('%d (R: %d, G: %d, B: %d)', [Integer(AcCmColor.ColorIndex), Integer(AcCmColor.Red), Integer(AcCmColor.Green), Integer(AcCmColor.Blue)]);
    Cells[0, 12]:= 'LeaderLineTypeId';             Cells[1, 12]:= AStyle.LeaderLineType;
    Cells[0, 13]:= 'LeaderLineWeight';             Cells[1, 13]:= AcLineWeightToStr(AStyle.LeaderLineWeight);
    Cells[0, 14]:= 'EnableLanding';                Cells[1, 14]:= BoolToStr(AStyle.EnableLanding, True);
    Cells[0, 15]:= 'LandingGap';                   Cells[1, 15]:= FormatFloat('0.###', Double(AStyle.LandingGap));
    Cells[0, 16]:= 'EnableDogleg';                 Cells[1, 16]:= BoolToStr(AStyle.EnableDogleg, True);
    Cells[0, 17]:= 'DoglegLength';                 Cells[1, 17]:= FormatFloat('0.###', Double(AStyle.DoglegLength));
    Cells[0, 18]:= 'ArrowSymbol';                  Cells[1, 18]:= AStyle.ArrowSymbol;
    Cells[0, 19]:= 'ArrowSize';                    Cells[1, 19]:= FormatFloat('0.###', Double(AStyle.ArrowSize));
    Cells[0, 20]:= 'TextStyle';                    Cells[1, 20]:= String(AStyle.TextStyle);
    Cells[0, 21]:= 'TextLeftAttachmentType';       Cells[1, 21]:= AcTextAttachmentTypeToStr(AStyle.TextLeftAttachmentType);
    Cells[0, 22]:= 'TextRightAttachmentType';      Cells[1, 22]:= AcTextAttachmentTypeToStr(AStyle.TextRightAttachmentType);
    Cells[0, 23]:= 'TextColor';                    AcCmColor:= AStyle.TextColor; Cells[1, 23]:= Format('%d (R: %d, G: %d, B: %d)', [Integer(AcCmColor.ColorIndex), Integer(AcCmColor.Red), Integer(AcCmColor.Green), Integer(AcCmColor.Blue)]);
    Cells[0, 24]:= 'TextHeight';                   Cells[1, 24]:= FormatFloat('0.###', Double(AStyle.TextHeight));
    Cells[0, 25]:= 'EnableFrameText';              Cells[1, 25]:= BoolToStr(AStyle.EnableFrameText, True);
    Cells[0, 26]:= 'AlignSpace';                   Cells[1, 26]:= FormatFloat('0.###', Double(AStyle.AlignSpace));
    Cells[0, 27]:= 'Block';                        Cells[1, 27]:= AStyle.Block;
    Cells[0, 28]:= 'BlockColor';                   AcCmColor:= AStyle.BlockColor; Cells[1, 28]:= Format('%d (R: %d, G: %d, B: %d)', [Integer(AcCmColor.ColorIndex), Integer(AcCmColor.Red), Integer(AcCmColor.Green), Integer(AcCmColor.Blue)]);
    Cells[0, 29]:= 'EnableBlockScale';             Cells[1, 29]:= BoolToStr(AStyle.EnableBlockScale, True);
    Cells[0, 30]:= 'BlockScale';                   Cells[1, 30]:= FormatFloat('0.###', Double(AStyle.BlockScale));
    Cells[0, 31]:= 'EnableBlockRotation';          Cells[1, 31]:= BoolToStr(AStyle.EnableBlockRotation, True);
    Cells[0, 32]:= 'BlockRotation';                Cells[1, 32]:= FormatFloat('0.###', Double(AStyle.BlockRotation));
    Cells[0, 33]:= 'BlockConnectionType';          Cells[1, 33]:= AcBlockConnectionTypeToStr(AStyle.BlockConnectionType);
    Cells[0, 34]:= 'ScaleFactor';                  Cells[1, 34]:= FormatFloat('0.###', Double(AStyle.ScaleFactor));
    Cells[0, 35]:= 'OverwritePropChanged';         Cells[1, 35]:= BoolToStr(AStyle.OverwritePropChanged, True);
    Cells[0, 36]:= 'Annotative';                   Cells[1, 36]:= BoolToStr(AStyle.Annotative, True);
    Cells[0, 37]:= 'BreakSize';                    Cells[1, 37]:= FormatFloat('0.###', Double(AStyle.BreakSize));
    Cells[0, 38]:= 'TextString';                   Cells[1, 38]:= AStyle.TextString;
    Cells[0, 39]:= 'TextAngleType';                Cells[1, 39]:= AcTextAngleTypeToStr(AStyle.TextAngleType);
    Cells[0, 40]:= 'TextAlignmentType';            Cells[1, 40]:= AcTextAlignmentTypeToStr(AStyle.TextAlignmentType);
  end;
end;

procedure TfrmMLeader.btnAddMLeaderStyleClick(Sender: TObject);
var
  MLeaderDictionary, MLeaderStyle: OleVariant;
begin
  //  
  try
    MLeaderDictionary:= Acad.ActiveDocument.Dictionaries.Item('ACAD_MLEADERSTYLE');
  except
    raise EOleError.Create(' MultiLeader  !');
  end;
  //   .       (
  //    ) -   
  MLeaderStyle:= MLeaderDictionary.AddObject(edNewStyleName.Text, 'AcDbMLeaderStyle');
  //    .       :
  // "EOleException with message "Null object ID",     AutoCAD- 
  //   TextStyle  .
  MLeaderStyle.TextStyle:= Acad.ActiveDocument.ActiveTextStyle.Name;
  //     
  MLeaderStyle.LeaderLineType:= acSplineLeader;
end;

procedure TfrmMLeader.btnSetCurrStyleClick(Sender: TObject);
begin
  with lbMLeaderStyles do
  begin
    if ItemIndex < 0 then Exit;
    Acad.ActiveDocument.SetVariable('CMLEADERSTYLE', Items[ItemIndex]);
  end;
end;

procedure TfrmMLeader.btnGetMLeaderInfoClick(Sender: TObject);
const
  fmtClusterCount = #13#10'  = %d.'#13#10;
  fmtClusterInfo = #13#10' = %d.   = %d.   X, Y, Z:'#13#10;
var
  BasePnt, Entity, LineIndexes, Coords: OleVariant;
  Obj: IDispatch;
  i, j, k, LeaderLineCounter, LeaderCount, iLBnd, iHBnd, cLBnd, cHBnd: Longint;
  S: String;
begin
  try //  
    Acad.ActiveDocument.Utility.GetEntity(Obj, BasePnt, #13' MLeader: ');
    Entity:= Obj;
  except
    Exit;
  end;
  //    MLeader -  
  if Entity.EntityType <> acMLeader then Exit;

  LeaderCount:= Entity.LeaderCount; //  
  Acad.ActiveDocument.Utility.Prompt(Format(fmtClusterCount, [LeaderCount]));
  //  
  LeaderLineCounter:= 0;
  for i:= 0 to LeaderCount - 1 do
  begin
    //   i- .   = (iHBnd - iLBnd) + 1
    LineIndexes:= Entity.GetLeaderLineIndexes(i);
    iLBnd:= VarArrayLowBound(LineIndexes, 1);
    iHBnd:= VarArrayHighBound(LineIndexes, 1);
    //     
    Acad.ActiveDocument.Utility.Prompt(Format(fmtClusterInfo, [i, (iHBnd - iLBnd) + 1]));
    //   i- 
    for j:= iLBnd to iHBnd do
    begin
      //   3D-  
      Coords:= Entity.GetLeaderLineVertices(LeaderLineCounter);
      cLBnd:= VarArrayLowBound(Coords, 1);
      cHBnd:= VarArrayHighBound(Coords, 1);
      //       
      S:= '';
      for k:= cLBnd to cHBnd do
        S:= S + Format('%8.3f', [Double(Coords[k])]);
      Acad.ActiveDocument.Utility.Prompt(S + #13#10);
      //    
      Inc(LeaderLineCounter);
    end;
  end;
end;

procedure TfrmMLeader.btnAddTxtMLeaderClick(Sender: TObject);
var
  P1, P2, V, Leader: OleVariant;
  N: Integer;
begin
  //  
  P1:= Acad.ActiveDocument.Utility.GetPoint(, ' : ');
  P2:= Acad.ActiveDocument.Utility.GetPoint(P1, ' : ');
  //   (2  MLeader,  6   )
  V:= VarArrayCreate([0, 5], varDouble);
  V[0]:= P1[0];
  V[1]:= P1[1];
  V[2]:= P1[2];
  V[3]:= P2[0];
  V[4]:= P2[1];
  V[5]:= P2[2];
  //  MLeader.     MLeader  ,  
  //          MText
  Leader:= Acad.ActiveDocument.ModelSpace.AddMLeader(V, N);
  //  
  Leader.TextString:= edTextString.Text;  //   (  )
  Leader.ArrowheadType:= acArrowDefault;  //   
  Leader.ArrowheadSize:= 4;               //  
  Leader.DogLegged:= False;               //   
  Leader.DoglegLength:= 0;                //   = 0
  Leader.LandingGap:= 2;                  //     -
  //  1-   -      
  Leader.TextLeftAttachmentType:= acAttachmentBottomOfTopLine;
  Leader.TextRightAttachmentType:= acAttachmentBottomOfTopLine;

  Leader.TextFrameDisplay:= False;        //   
  Leader.TextBackgroundFill:= False;      //    
  Leader.TextDirection:= acLeftToRight;   //  -
  Leader.TextHeight:= 3.5;                //  
  Leader.TextWidth:= 0;                   //   (     )
  Leader.TextJustify:= acAttachmentPointBottomCenter; //  
end;

procedure TfrmMLeader.btnAddBlkMLeaderClick(Sender: TObject);
var
  P1, P2, V, Leader: OleVariant;
  N: Integer;
begin
  if Application.MessageBox(PChar('        - . ?'), PChar(Application.Title), MB_ICONQUESTION or MB_YESNO) <> IDYES then Exit;
  //  
  P1:= Acad.ActiveDocument.Utility.GetPoint(, ' : ');
  P2:= Acad.ActiveDocument.Utility.GetPoint(P1, ' : ');
  //   (2  MLeader,  6   )
  V:= VarArrayCreate([0, 5], varDouble);
  V[0]:= P1[0];
  V[1]:= P1[1];
  V[2]:= P1[2];
  V[3]:= P2[0];
  V[4]:= P2[1];
  V[5]:= P2[2];
  //  MLeader.     MLeader  ,  
  //          
  Leader:= Acad.ActiveDocument.ModelSpace.AddMLeader(V, N);
  //  
  Leader.ContentBlockType:= acBlockBox;   //   ()
  Leader.LeaderType:= acStraightLeader;   //   -  ( )
  Leader.ArrowheadType:= acArrowDefault;  //   
  Leader.ArrowheadSize:= 4;               //  
  Leader.DogLegged:= True;                //   
  Leader.DoglegLength:= 5;                //   = 5
end;

procedure TfrmMLeader.btnAdd2MLeaderClick(Sender: TObject);
var
  P1, P2, V, Leader: OleVariant;
  N: Integer;
begin
  //  
  P1:= Acad.ActiveDocument.Utility.GetPoint(, ' : ');
  P2:= Acad.ActiveDocument.Utility.GetPoint(P1, ' : ');
  //   (2  MLeader,  6   )
  V:= VarArrayCreate([0, 5], varDouble);
  V[0]:= P1[0];
  V[1]:= P1[1];
  V[2]:= P1[2];
  V[3]:= P2[0];
  V[4]:= P2[1];
  V[5]:= P2[2];
  //  MLeader.    1    0
  Leader:= Acad.ActiveDocument.ModelSpace.AddMLeader(V, N);

  //     
  V[0]:= V[0] + 5; //  X      5
  
  //      
  Leader.AddLeaderLine(0, V);
  
  //   
  Leader.TextString:= edTextString.Text;
end;

procedure TfrmMLeader.btnAddSomeMLeaderClick(Sender: TObject);
var
  P1, P2, V, Leader: OleVariant;
  N: Integer;
begin
  //  
  P1:= Acad.ActiveDocument.Utility.GetPoint(, ' : ');
  P2:= Acad.ActiveDocument.Utility.GetPoint(P1, ' : ');
  //   (2  MLeader,  6   )
  V:= VarArrayCreate([0, 5], varDouble);
  V[0]:= P1[0];
  V[1]:= P1[1];
  V[2]:= P1[2];
  V[3]:= P2[0];
  V[4]:= P2[1];
  V[5]:= P2[2];
  //  MLeader
  Leader:= Acad.ActiveDocument.ModelSpace.AddMLeader(V, N);

  //     
  V:= VarArrayCreate([0, 11], varDouble);
  V[0]:= P1[0];
  V[1]:= P1[1];
  V[2]:= P1[2];
  V[3]:= P1[0];
  V[4]:= P1[1] + 10;
  V[5]:= P1[2];
  V[6]:= P2[0];
  V[7]:= P1[1] + 10;
  V[8]:= P1[2];
  V[9]:= P2[0];
  V[10]:= P2[1];
  V[11]:= P2[2];
  //   
  Leader.AddLeaderLine(0, V);
  
  //   
  Leader.TextString:= edTextString.Text;
end;

procedure TfrmMLeader.btnAdd2cMLeaderClick(Sender: TObject);
var
  P1, P2, V, Leader: OleVariant;
  N: Integer;
begin
  //  
  P1:= Acad.ActiveDocument.Utility.GetPoint(, ' : ');
  P2:= Acad.ActiveDocument.Utility.GetPoint(P1, ' : ');
  //   (2  MLeader,  6   )
  V:= VarArrayCreate([0, 5], varDouble);
  V[0]:= P1[0];
  V[1]:= P1[1];
  V[2]:= P1[2];
  V[3]:= P2[0];
  V[4]:= P2[1];
  V[5]:= P2[2];
  //  MLeader
  Leader:= Acad.ActiveDocument.ModelSpace.AddMLeader(V, N);

  V[0]:= V[0] + 5; //  X      5
  //  
  Leader.AddLeaderLineEx(V);

  //   
  Leader.TextString:= edTextString.Text;
end;

procedure TfrmMLeader.btnAdd3MLeaderClick(Sender: TObject);
var
  P1, P2, V, Leader: OleVariant;
  N: Integer;
begin
  //  
  P1:= Acad.ActiveDocument.Utility.GetPoint(, ' : ');
  P2:= Acad.ActiveDocument.Utility.GetPoint(P1, ' : ');
  //   (2  MLeader,  6   )
  V:= VarArrayCreate([0, 5], varDouble);
  V[0]:= P1[0];
  V[1]:= P1[1];
  V[2]:= P1[2];
  V[3]:= P2[0];
  V[4]:= P2[1];
  V[5]:= P2[2];
  //  MLeader
  Leader:= Acad.ActiveDocument.ModelSpace.AddMLeader(V, N);

  //   
  N:= Leader.AddLeader;
  //      (  ,   )
  V[0]:= V[0] + 5; //  X      5
  Leader.AddLeaderLine(N, V); //   

  //   
  Leader.TextString:= edTextString.Text;
end;

procedure TfrmMLeader.btnAddFullMLeaderClick(Sender: TObject);
var
  CurrMLeaderStyle: String;
  MLeaderDictionary, MLeaderStyle: OleVariant;
  P1, P2: OleVariant;
  V, Leader: OleVariant;
  i, N: Integer;
begin
  //  
  CurrMLeaderStyle:= Acad.ActiveDocument.GetVariable('CMLEADERSTYLE');
  //  
  try
    MLeaderDictionary:= Acad.ActiveDocument.Dictionaries.Item('ACAD_MLEADERSTYLE');
  except
    raise EOleError.Create(' MultiLeader  !');
  end;
  //     ;
  try
    N:= MLeaderDictionary.Count;
    for i:= 0 to N - 1 do
    begin
      if MLeaderDictionary.Item(i).ObjectName = 'AcDbMLeaderStyle' then
      begin
        MLeaderStyle:= MLeaderDictionary.Item(i);
        if MLeaderStyle.Name = CurrMLeaderStyle then //  ?
          Break;
      end;
    end;
  except
    Exit;
  end;
  try
    P1:= Acad.ActiveDocument.Utility.GetPoint(, ' : ');
    P2:= Acad.ActiveDocument.Utility.GetPoint(P1, ' : ');

    V:= VarArrayCreate([0, 5], varDouble);
    V[0]:= P1[0];
    V[1]:= P1[1];
    V[2]:= P1[2];
    V[3]:= P2[0];
    V[4]:= P2[1];
    V[5]:= P2[2];

    Leader:= Acad.ActiveDocument.ModelSpace.AddMLeader(V, N);

    Leader.ContentType:= cbContentType.ItemIndex;
    Leader.LeaderType:= cbLeaderType.ItemIndex;
    Leader.ArrowheadType:= cbArrowheadType.ItemIndex;
    Leader.ArrowheadSize:= StrToFloat(edArrowheadSize.Text);
    Leader.DogLegged:= chbDogLegged.Checked;
    Leader.DoglegLength:= StrToFloat(edDoglegLength.Text);
    Leader.LandingGap:= StrToFloat(edLandingGap.Text);

    case Leader.ContentType of
      acNoneContent : begin
                      end;
      acBlockContent: begin
                        Leader.ContentBlockType:= cbContentBlockType.ItemIndex;
                        Leader.BlockConnectionType:= cbBlockConnectionType.ItemIndex;
                      end;
      acMTextContent: begin
                        Leader.TextLeftAttachmentType:= cbTextLeftAttachmentType.ItemIndex;
                        Leader.TextRightAttachmentType:= cbTextRightAttachmentType.ItemIndex;
                        Leader.TextFrameDisplay:= chbTextFrameDisplay.Checked;
                        Leader.TextBackgroundFill:= chbTextBackgroundFill.Checked;
                        Leader.TextRotation:= StrToFloat(edTextRotation.Text);
                        Leader.TextLineSpacingFactor:= StrToFloat(edTextLineSpacingFactor.Text);
                        Leader.TextLineSpacingDistance:= StrToFloat(edTextLineSpacingDistance.Text);
                        Leader.TextLineSpacingStyle:= cbTextLineSpacingStyle.ItemIndex + 1;
                        if not MLeaderStyle.Annotative then
                        begin
                          Leader.TextDirection:= cbTextDirection.ItemIndex + 1;
                          Leader.ScaleFactor:= StrToFloat(edScaleFactor.Text);
                          Leader.TextJustify:= cbTextJustify.ItemIndex + 1
                        end;
                        Leader.TextHeight:= StrToFloat(edTextHeight.Text);
                        Leader.TextWidth:= StrToFloat(edTextWidth.Text);
                        Leader.TextString:= edTextString.Text;
                      end;
    end;
  finally
  end;
end;

procedure TfrmMLeader.lbMLeaderStylesDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  S: String;
  OldColor: TColor;
  R: TRect;
begin
  with (Control as TListBox) do
  begin
    R:= Rect;
    Canvas.FillRect(Rect);
    if Index < Count then
    begin
      Inc(R.Left, 2);
      S:= Items[Index];
      DrawText(Canvas.Handle, PChar(S), Length(S), R, DT_SINGLELINE or DT_VCENTER or DT_NOPREFIX);
      if Integer(Items.Objects[Index]) = 1 then
      begin
        OldColor:= Canvas.Brush.Color;
        Canvas.Brush.Color:= clRed;
        Inc(R.Left, R.Right - (R.Bottom - R.Top) - 2);
        InflateRect(R, -2, -2);
        Canvas.Ellipse(R);
        Canvas.Brush.Color:= OldColor;
      end;
    end;
    if odSelected in State then
    begin
      Canvas.DrawFocusRect(Rect);
      Canvas.DrawFocusRect(Rect);
    end;
  end;
end;

end.
