unit Utils;

interface

uses
  SysUtils, ActiveX, AutoCAD_TLB;

  function AcMLeaderTypeToStr(AType: TOleEnum): String;
  function AcLineWeightToStr(ALineWeight: TOleEnum): String;
  function AcDimArrowheadTypeToStr(AType: TOleEnum): String;
  function AcBlockConnectionTypeToStr(AType: TOleEnum): String;
  function AcAttachmentPointToStr(APoint: TOleEnum): String;
  function AcDrawingDirectionToStr(ADirection: TOleEnum): String;
  function AcLineSpacingStyleToStr(AStyle: TOleEnum): String;
  function AcTextAttachmentTypeToStr(AType: TOleEnum): String;
  function AcPredefBlockTypeToStr(AType: TOleEnum): String;
  function AcMLeaderContentTypeToStr(AType: TOleEnum): String;
  function AcDrawMLeaderOrderTypeToStr(AType: TOleEnum): String;
  function AcDrawLeaderOrderTypeToStr(AType: TOleEnum): String;
  function AcSegmentAngleTypeToStr(AType: TOleEnum): String;
  function AcTextAngleTypeToStr(AType: TOleEnum): String;
  function AcTextAlignmentTypeToStr(AType: TOleEnum): String;

implementation


function AcMLeaderTypeToStr(AType: TOleEnum): String;
begin
  case AType of
    acStraightLeader : Result:= 'acStraightLeader';
    acSplineLeader   : Result:= 'acSplineLeader';
    acInVisibleLeader: Result:= 'acInVisibleLeader';
  end;
end;

function AcLineWeightToStr(ALineWeight: TOleEnum): String;
begin
  case ALineWeight of
    acLnWtByLayer    : Result:= 'acLnWtByLayer';
    acLnWtByBlock    : Result:= 'acLnWtByBlock';
    acLnWtByLwDefault: Result:= 'acLnWtByLwDefault';
  else
    Result:= Format('acLnWt%3d', [ALineWeight]);
  end;
end;

function AcDimArrowheadTypeToStr(AType: TOleEnum): String;
begin
  case AType of
    acArrowDefault    : Result:= 'acArrowDefault';
    acArrowClosedBlank: Result:= 'acArrowClosedBlank';
    acArrowClosed     : Result:= 'acArrowClosed';
    acArrowDot        : Result:= 'acArrowDot';
    acArrowArchTick   : Result:= 'acArrowArchTick';
    acArrowOblique    : Result:= 'acArrowOblique';
    acArrowOpen       : Result:= 'acArrowOpen';
    acArrowOrigin     : Result:= 'acArrowOrigin';
    acArrowOrigin2    : Result:= 'acArrowOrigin2';
    acArrowOpen90     : Result:= 'acArrowOpen90';
    acArrowOpen30     : Result:= 'acArrowOpen30';
    acArrowDotSmall   : Result:= 'acArrowDotSmall';
    acArrowDotBlank   : Result:= 'acArrowDotBlank';
    acArrowSmall      : Result:= 'acArrowSmall';
    acArrowBoxBlank   : Result:= 'acArrowBoxBlank';
    acArrowBoxFilled  : Result:= 'acArrowBoxFilled';
    acArrowDatumBlank : Result:= 'acArrowDatumBlank';
    acArrowDatumFilled: Result:= 'acArrowDatumFilled';
    acArrowIntegral   : Result:= 'acArrowIntegral';
    acArrowNone       : Result:= 'acArrowNone';
    acArrowUserDefined: Result:= 'acArrowUserDefined';
  end;
end;

function AcBlockConnectionTypeToStr(AType: TOleEnum): String;
begin
  case AType of
    acConnectExtents: Result:= 'acConnectExtents';
    acConnectBase   : Result:= 'acConnectBase';
  end;
end;

function AcAttachmentPointToStr(APoint: TOleEnum): String;
begin
  case APoint of
    acAttachmentPointTopLeft     : Result:= 'acAttachmentPointTopLeft';
    acAttachmentPointTopCenter   : Result:= 'acAttachmentPointTopCenter';
    acAttachmentPointTopRight    : Result:= 'acAttachmentPointTopRight';
    acAttachmentPointMiddleLeft  : Result:= 'acAttachmentPointMiddleLeft';
    acAttachmentPointMiddleCenter: Result:= 'acAttachmentPointMiddleCenter';
    acAttachmentPointMiddleRight : Result:= 'acAttachmentPointMiddleRight';
    acAttachmentPointBottomLeft  : Result:= 'acAttachmentPointBottomLeft';
    acAttachmentPointBottomCenter: Result:= 'acAttachmentPointBottomCenter';
    acAttachmentPointBottomRight : Result:= 'acAttachmentPointBottomRight';
  end;
end;

function AcDrawingDirectionToStr(ADirection: TOleEnum): String;
begin
  case ADirection of
    acLeftToRight: Result:= 'acLeftToRight';
    acRightToLeft: Result:= 'acRightToLeft';
    acTopToBottom: Result:= 'acTopToBottom';
    acBottomToTop: Result:= 'acBottomToTop';
    acByStyle    : Result:= 'acByStyle';
  end;
end;

function AcLineSpacingStyleToStr(AStyle: TOleEnum): String;
begin
  case AStyle of
    acLineSpacingStyleAtLeast: Result:= 'acLineSpacingStyleAtLeast';
    acLineSpacingStyleExactly: Result:= 'acLineSpacingStyleExactly';
  end;
end;

function AcTextAttachmentTypeToStr(AType: TOleEnum): String;
begin
  case AType of
    acAttachmentTopOfTop       : Result:= 'acAttachmentTopOfTop';
    acAttachmentMiddleOfTop    : Result:= 'acAttachmentMiddleOfTop';
    acAttachmentBottomOfTop    : Result:= 'acAttachmentBottomOfTop';
    acAttachmentBottomOfTopLine: Result:= 'acAttachmentBottomOfTopLine';
    acAttachmentMiddle         : Result:= 'acAttachmentMiddle';
    acAttachmentMiddleOfBottom : Result:= 'acAttachmentMiddleOfBottom';
    acAttachmentBottomOfBottom : Result:= 'acAttachmentBottomOfBottom';
    acAttachmentBottomLine     : Result:= 'acAttachmentBottomLine';
    acAttachmentAllLine        : Result:= 'acAttachmentAllLine';
  end;
end;

function AcPredefBlockTypeToStr(AType: TOleEnum): String;
begin
  case AType of
    acBlockImperial   : Result:= 'acBlockImperial';
    acBlockSlot       : Result:= 'acBlockSlot';
    acBlockCircle     : Result:= 'acBlockCircle';
    acBlockBox        : Result:= 'acBlockBox';
    acBlockHexagon    : Result:= 'acBlockHexagon';
    acBlockTriangle   : Result:= 'acBlockTriangle';
    acBlockUserDefined: Result:= 'acBlockUserDefined';
  end;
end;

function AcMLeaderContentTypeToStr(AType: TOleEnum): String;
begin
  case AType of
    acNoneContent : Result:= 'acNoneContent';
    acBlockContent: Result:= 'acBlockContent';
    acMTextContent: Result:= 'acMTextContent';
  end;
end;

function AcDrawMLeaderOrderTypeToStr(AType: TOleEnum): String;
begin
  case AType of
    acDrawContentFirst: Result:= 'acDrawContentFirst';
    acDrawLeaderFirst : Result:= 'acDrawLeaderFirst';
  end;
end;

function AcDrawLeaderOrderTypeToStr(AType: TOleEnum): String;
begin
  case AType of
    acDrawLeaderHeadFirst: Result:= 'acDrawLeaderHeadFirst';
    acDrawLeaderTailFirst : Result:= 'acDrawLeaderTailFirst';
  end;
end;

function AcSegmentAngleTypeToStr(AType: TOleEnum): String;
begin
  case AType of
    acDegreesAny : Result:= 'acDegreesAny';
    acDegrees15  : Result:= 'acDegrees15';
    acDegrees30  : Result:= 'acDegrees30';
    acDegrees45  : Result:= 'acDegrees45';
    acDegrees60  : Result:= 'acDegrees60';
    acDegrees90  : Result:= 'acDegrees90';
    acDegreesHorz: Result:= 'acDegreesHorz';
  end;
end;

function AcTextAngleTypeToStr(AType: TOleEnum): String;
begin
  case AType of
    acInsertAngle            : Result:= 'acInsertAngle';
    acHorizontalAngle        : Result:= 'acHorizontalAngle';
    acAlwaysRightReadingAngle: Result:= 'acAlwaysRightReadingAngle';
  end;
end;

function AcTextAlignmentTypeToStr(AType: TOleEnum): String;
begin
  case AType of
    acLeftAlignment  : Result:= 'acLeftAlignment';
    acCenterAlignment: Result:= 'acCenterAlignment';
    acRightAlignment : Result:= 'acRightAlignment';
  end;
end;

end.
 